;- > -- Constands -- <<
  #LIBAVCODEC_VERSION_MAJOR = 52
  #LIBAVCODEC_VERSION_MINOR = 72
  #LIBAVCODEC_VERSION_MICRO = 2
  
  #MAX_STREAMS        = 20
  #MAX_PROGRAMMS      = 10000
  #AV_PARSER_PTS_NB   = 4
  #AVPALETTE_COUNT    = 256
  #MAX_STD_TIMEBASES  = (60 * 12 + 5)
  #MAX_REORDER_DELAY  = 16 
  
;- > -- Enumerations -- <<  
   Enumeration
    #PIX_FMT_NONE = -1  
    #PIX_FMT_YUV420P  
    #PIX_FMT_YUYV422  
    #PIX_FMT_RGB24  
    #PIX_FMT_BGR24   
    #PIX_FMT_YUV422P 
    #PIX_FMT_YUV444P  
    #PIX_FMT_YUV410P  
    #PIX_FMT_YUV411P  
    #PIX_FMT_GRAY8 
    #PIX_FMT_MONOWHITE 
    #PIX_FMT_MONOBLACK  
    #PIX_FMT_PAL8  
    #PIX_FMT_YUVJ420P  
    #PIX_FMT_YUVJ422P 
    #PIX_FMT_YUVJ444P  
    #PIX_FMT_XVMC_MPEG2_MC 
    #PIX_FMT_XVMC_MPEG2_IDCT  
    #PIX_FMT_UYVY422  
    #PIX_FMT_UYYVYY411  
    #PIX_FMT_BGR8 
    #PIX_FMT_BGR4  
    #PIX_FMT_BGR4_BYTE  
    #PIX_FMT_RGB8  
    #PIX_FMT_RGB4
    #PIX_FMT_RGB4_BYTE 
    #PIX_FMT_NV12  
    #PIX_FMT_NV21  
    #PIX_FMT_ARGB 
    #PIX_FMT_RGBA 
    #PIX_FMT_ABGR  
    #PIX_FMT_BGRA  
    #PIX_FMT_GRAY16BE
    #PIX_FMT_GRAY16LE  
    #PIX_FMT_YUV440P  
    #PIX_FMT_YUVJ440P  
    #PIX_FMT_YUVA420P 
    #PIX_FMT_VDPAU_H264  
    #PIX_FMT_VDPAU_MPEG1 
    #PIX_FMT_VDPAU_MPEG2  
    #PIX_FMT_VDPAU_WMV3 
    #PIX_FMT_VDPAU_VC1  
    #PIX_FMT_RGB48BE  
    #PIX_FMT_RGB48LE  
    #PIX_FMT_RGB565BE  
    #PIX_FMT_RGB565LE  
    #PIX_FMT_RGB555BE  
    #PIX_FMT_RGB555LE  
    #PIX_FMT_BGR565BE 
    #PIX_FMT_BGR565LE  
    #PIX_FMT_BGR555BE  
    #PIX_FMT_BGR555LE  
    #PIX_FMT_VAAPI_MOCO  
    #PIX_FMT_VAAPI_IDCT  
    #PIX_FMT_VAAPI_VLD  
    #PIX_FMT_YUV420P16LE  
    #PIX_FMT_YUV420P16BE 
    #PIX_FMT_YUV422P16LE 
    #PIX_FMT_YUV422P16BE 
    #PIX_FMT_YUV444P16LE  
    #PIX_FMT_YUV444P16BE  
    #PIX_FMT_VDPAU_MPEG4 
    #PIX_FMT_DXVA2_VLD  
    #PIX_FMT_RGB444BE  
    #PIX_FMT_RGB444LE 
    #PIX_FMT_BGR444BE 
    #PIX_FMT_BGR444LE  
    #PIX_FMT_Y400A  
    #PIX_FMT_BGR48LE
    #PIX_FMT_BGR48BE  
    #PIX_FMT_NB 
  EndEnumeration 

  Enumeration
    #PBAVFormatContext
    #PBAVChapter
    #PBAVProgram
    #PBAVPacketList
    #PBAVStream
    #PBAVFrac
    #PBAVCodecContext
    #PBAVHWAccel
    #PBAVPaletteControl
    #PBAVFrame
    #PBRcOverride
    #PBAVCodec
    #PBAVPacket
    #PBAVDictionaryEntry
    #PBAVProbeData
    #PBAVIndexEntry
    #PBAVCodecParserContext
    #PBAVCodecParser
    #PBAVIOContext
    #PBAVOutputFormat
    #PBAVInputFormat
    #PBAVClass
  EndEnumeration  

  Enumeration
    #AVMEDIA_TYPE_UNKNOWN = -1
    #AVMEDIA_TYPE_VIDEO
    #AVMEDIA_TYPE_AUDIO
    #AVMEDIA_TYPE_DATA
    #AVMEDIA_TYPE_SUBTITLE
    #AVMEDIA_TYPE_ATTACHMENT
    #AVMEDIA_TYPE_NB    
  EndEnumeration  
  
;- > -- Structures -- <<

;- AVRational 
;  http://ffmpeg.org/doxygen/trunk/structAVRational.html
Structure AVRational 
  num.l
  den.l
EndStructure


;- AVOption
;  http://ffmpeg.org/doxygen/trunk/structAVOption.html
Structure AVOption
  *name
  *help
  offset.l
  type.l                                    ;- enum to do
  StructureUnion
    dbl.d
    *str
    i64.q
    q.AVRational
  EndStructureUnion
  min.d
  max.d
  flags.l
  *unit.b
EndStructure


;- AVClass
;  http://ffmpeg.org/doxygen/trunk/structAVClass.html
Structure AVClass
  *class_name.b
  *item_name.b
  *option.AVOption                          
  version.l
  log_level_offset_offset.l
  parent_log_context_offset.l
  ; struct AVOption *(* 	opt_find )(void *obj, const char *name, const char *unit, int opt_flags, int search_flags) ??????????
  dummy.q
EndStructure


;- AVCodecTag 
;  http://ffmpeg.org/doxygen/trunk/structAVCodecTag.html
Structure AVCodecTag 
  id.l
  tag.l
EndStructure

;- AVMetadataConv 
;  http://ffmpeg.org/doxygen/trunk/structAVMetadataConv.html
Structure AVMetadataConv 
  *native.b
  *generic.b
EndStructure


;- AVInputFormat 
;  http://ffmpeg.org/doxygen/trunk/structAVInputFormat.html
Structure AVInputFormat 
  *name.b
  *long_name.b 
  priv_data_size.l
  *read_probe.l
  *read_header.l
  *read_packet.l
  *read_close.l
  *read_seek.l
  *read_timestamp.l
  flags.l
  *extensions.b
  value.l
  *read_play.l
  *read_pause.l
  *codec_tag.AVCodecTag                     
  *read_seek2.l
  *metadata_conv.AVMetadataConv             
  *priv_class.AVClass                       
  *Next.AVInputFormat  
EndStructure


;- AVOutputFormat 
;  http://ffmpeg.org/doxygen/trunk/structAVOutputFormat.html
Structure AVOutputFormat 
  *name.b
  *long_name.b
  *mime_type.b
  *extensions.b
  priv_data_size.l
  audio_codec.l                            
  video_codec.l
  write_header.l
  write_packet.l
  write_trailer.l
  flags.l
  *dummy
  *interleave_packet.l
  *codec_tag.AVCodecTag                     
  subtitle_codec.l
  *metadata_conv.AVMetadataConv
  *priv_class.AVClass
  query_codec.l
  *get_output_timestamp.l
  *Next.AVOutputFormat
EndStructure


;- AVIOContext  
;  http://ffmpeg.org/doxygen/trunk/structAVIOContext.html
Structure AVIOContext  
  *buffer.b
  buffer_size.l
  *buf_ptr.b
  *buf_end.b
  *opaque
  *read_packet.l
  *write_packet.l
  *seek.q
  pos.q
  must_flush.l
  eof_reached.l
  write_flag.l
  is_streamed.l
  max_packet_size.l
  checksum.l
  *checksum_ptr.l
  *ubdate_checksum.l
  error.l
  *read_pause.l
  *read_seek.l
  seekable.l
EndStructure


;- AVCodecParser
;  http://ffmpeg.org/doxygen/trunk/structAVCodecParser.html
Structure AVCodecParser
  codec_ids.l[5]
  priv_data_size.l
  *parser_init.l
  *parser_parse.l
  *parser_close.l
  *split.l
  *Next.AVCodecParser
EndStructure


;- AVCodecParserContext 
;  http://ffmpeg.org/doxygen/trunk/structAVCodecParserContext.html
Structure AVCodecParserContext 
  *priv_data.l
  *parser.AVCodecParser                     
  frame_offset.q
  cur_offset.q
  next_frame_offset.q
  pict_type.l
  repeat_pict.l
  pts.q
  dts.q
  last_pts.q
  last_dts.q
  fetch_timestamp.l
  cur_frame_start_index.l
  cur_frame_offset.q[#AV_PARSER_PTS_NB]
  cur_frame_pts.q[#AV_PARSER_PTS_NB]
  cur_frame_dts.q[#AV_PARSER_PTS_NB]
  flgs.l
  offset.q
  cur_frame_end.q[#AV_PARSER_PTS_NB]
  key_frame.l
  convergence_duration.q
  dts_sync_point.l
  dts_ref_dts_delta.l
  pts_dts_delta.l
  cur_frame_pos.q[#AV_PARSER_PTS_NB]
  pos.q
  last_pos.q
EndStructure


;- AVIndexEntry
;  http://ffmpeg.org/doxygen/trunk/structAVIndexEntry.html
Structure AVIndexEntry
  pos.q
  timestamp.q
  flags.l
  size.l
  min_distance.l
EndStructure

;- AVProbeData 
;  http://ffmpeg.org/doxygen/trunk/structAVProbeData.html
Structure AVProbeData 
  *filname.b
  *buf.b
  buf_size.l
EndStructure


;- AVDictionaryEntry  
;  http://ffmpeg.org/doxygen/trunk/structAVDictionaryEntry.html
Structure AVDictionaryEntry  
  *key.b
  *value.b
EndStructure

;- AVDictionary 
;  http://ffmpeg.org/doxygen/trunk/structAVDictionary.html
Structure AVDictionary 
  count.l
  *elems.AVDictionaryEntry
EndStructure

;- AVPacket  
;  http://ffmpeg.org/doxygen/trunk/structAVPacket.html
Structure sdata
  *Data.b  
  size.l
  type.l                                    ;- Enum to do
EndStructure

Structure AVPacket  
  pts.q
  dts.q
  *Data.b
  size.l
  stream_index.l
  flags.l
  side_data.sdata
  side_data_elems.l
  *destruct.l
  *priv.l
  pos.q
  convergence_duration.q
EndStructure


;. AVPackedList
;  http://ffmpeg.org/doxygen/trunk/structAVPacketList.html
Structure AVPackedList
  pkt.AVPacket
  *Next.AVPackedList
EndStructure

;- AVCodecDefault
;  http://ffmpeg.org/doxygen/trunk/structAVCodecDefault.html
Structure AVCodecDefault
  *key.b
  *value.b
EndStructure

;- AVCodec 
;  http://ffmpeg.org/doxygen/trunk/structAVCodec.html
Structure AVCodec 
  *name.b
  type.l                                   ;- Enum to do
  id.l                                     ;- Enum to do
  priv_data_size.l
  *init.l
  *encode.l
  *close.l
  *decode.l
  capabilities.l
*Next.AVCodec
*supported_framerates.AVRational
*defaults.AVCodecDefault
EndStructure


;- RcOverride 
;  http://ffmpeg.org/doxygen/trunk/structRcOverride.html
Structure RcOverride 
  start_frame.l
  end_frame.l
  qscale.f
  quality_factor.f
EndStructure

;- AVFrame
;  http://ffmpeg.org/doxygen/trunk/structAVFrame.html
Structure AVFrame
  *Data.b[4]
  linesize.l[4]
  base.b[4]
  key_frame.l
  pict_type.l                               ;- Enum
  pts.q
  coded_picture_number.l
  display_picture_number.l
  quality.l
  age.l
  reference.l
  *qscale_table.b
  qstride.l
  mbskip_table.b
  *motion_val.w[2]
  *mb_type.l
  motion_subsample_log2.b
  *opaque.l
  error.q[4]
  type.l
  repeat_pict.l
  qscale_type.l
  interlaced_frame.l
  top_field_first.l
  *pan_scan.AVPanScan                       ;- Struct to do
  palette_has_changed.l
  buffer_hints.l
  *dct_coeff.w
  ref_index .b[2]
  reordered_opaque.q
  *hwaccel_picture_private.l
  pkt_pts.q
  pkt_dts.q
  *owner.AVCodecContext
  *thread_opaque.l  
  best_effort_timestamp.q
  pkt_pos.q
  sample_aspect_ratio.AVRational
  width.l
  height.l
  format.l
EndStructure

;- AVPaletteControl
;  http://ffmpeg.org/doxygen/trunk/structAVPaletteControl.html
Structure AVPaletteControl
  palette_changed.l
  palette.l[#AVPALETTE_COUNT]
EndStructure

;- AVHWAccel 
;  http://ffmpeg.org/doxygen/trunk/structAVHWAccel.html
Structure AVHWAccel 
  *name.b
  type.l                                    ; Enum to do
  id.l                                      ; Enum to do
  pix_fmt.l                                 ; Enum to do
  capabilities.l
  *Next.AVHWAccel
  *start_frame.l
  *decode_slice.l
  *end_frame.l
  *priv_data_size.l
EndStructure


;- AVCodecContext
;  http://ffmpeg.org/doxygen/trunk/structAVCodecContext.html
Structure AVCodecContext
  *av_class.AVClass
  bit_rate.l
  bit_rate_tolerance.l
  flags.l
  sub_id.l
  me_method.l
  *extradata.b
  extradata_size.l
  time_base.AVRational
  width.l
  height.l
  gop_size.l
  pix_fmt.l                                 ;- Enum to do
  draw_horiz_band.l
  sample_rate.l
  frame_size.l
  frame_number.l
  delay.l
  qcompress.f
  qblur.f
  qmin.l
  qmax.l
  maxqdiff.l
  max_b_frames.l
  b_qaunt_factor.f
  rc_strategy.l
  b_frame_strategy.l
  *codec.AVCodec                            
  *priv_data.l
  rtp_payload_size.l
  *rtp_callback.l
  mv_bits.l
  header_bits.l
  i_tex_bits.l
  p_tex_bits.l
  i_count.l
  p_count.l
  skip_count.l
  misc_bits.l
  frame_bits.l
  *opaque.l
  codec_name.b[32]
  codec_type.l                              ;- enum
  codec_id.l                                ;- enum
  codec_tag.l
  workaround_bugs.l
  luma_elim_threshold.l
  chroma_elim_threshold.l
  strict_std_compiliance.l
  b_quant_offset.f
  error_recognition.l
  *get_buffer.l
  has_b_frames.l
  block_align.l
  parse_align.l
  parse_only.l
  mpeg_quant.l
  *stats_out.b
  *stats_in.b
  rc_qsquish.f
  rc_qmod_amp.f
  rc_qmod_freq.l
  *rc_override.RcOverride                   
  rc_override_count.l
  *rc_eq.b
  rc_max_rate.l
  rc_min_rate.l
  rc_buffer_size.l
  rc_buffer_aggressivity.f
  i_quant_factor.f
  i_quant_offset.f
  rc_initial_cplx.f
  dct_algo.l
  lumi_masking.f
  temporal_cplx_masking.f
  spatial_cplx_masking.f
  p_masking.f
  dark_masking.f
  idct_algo.l
  slice_count.l
  *slice_offset.l
  error_concealment.l
  dsp_mask.l
  bits_per_coded_sample.l
  prediction_method.l
  sample_aspect_ratio.AVRational
  *coded_frame.AVFrame                     
  Debug.l
  debug_mv.l
  error.q[4]
  me_cmp.l
  me_sub_cmp.l
  mb_cmp.l
  ildct_cmp.l
  dia_size.l
  last_predictor_count.l
  pre_me.l
  me_pre_cmp.l
  pre_dia_size.l
  me_subpel_quality.l
  *get_format.l                             ;- Enum to do
  dtg_active_format.l
  me_range.l
  intra_quant_bias.l
  inter_quant_bias.l
  color_table_id.l
  internal_buffer_count.l
  *internal_buffer.l
  global_quality.l
  coder_type.l
  context_model.l
  slice_flags.l
  xvmc_acceleration.l
  mb_decision.l
  *intra_matrix.q
  *inter_matrix.q
  stream_codec_tag.l
  scenechange_threshold.l
  lmin.l
  lmax.l
  *palctrl.AVPaletteControl                 
  noise_reduction.l
  *reget_buffer.l
  rc_initial_buffer_occupancy.l
  inter_threshold.l
  flags2.l
  error_rate.l
  antialias_algo.l
  quantizer_noise_shaping.l
  thread_count.l
  *execute.l
  *thread_opaque.l
  me_threshold.l
  mb_threshold.l
  intra_dc_precision.l
  nsse_weight.l
  skip_top.l
  skip_bottom.l
  profile.l
  level.l
  lowres.l
  coded_width.l
  coded_height.l
  frame_skip_threshold.l
  frame_skip_factor.l
  frame_skip_exp.l
  frame_skip_cmp.l
  border_masking.f
  mb_lmin.l
  mb_lmax.l
  me_penalty_compensation.l
  skip_loop_filter.l                        ;- Enum to do
  skip_idct.l                               ;- Enum to do
  skip_frame.l                              ;- Enum to do
  bidir_refine.l
  brd_scale.l
  crf.f
  cqp.l
  keyint_min.l
  refs.l
  chromaoffset.l
  bframebias.l
  trellis.l
  complexityblur.f
  deblockalpha.l
  deblockbeta.l
  partitions.l
  directpred.l
  cutoff.l
  scenechange_factor.l
  mv0_threshold.l
  b_sensitivity.l
  compression_level.l
  min_prediction_order.l
  max_prediction_order.l
  timecode_frame_start.q
  request_channels.l
  drc_scale.f
  reordered_opaque.q
  bits_per_raw_sample.l
  channel_layout.q
  request_channel_layout.q
  rc_max_available_vbv_use.f
  rc_min_vbv_overflow_use.f
  *hwaccel.AVHWAccel                       
  ticks_per_frame.l
  *hwaccel_context.l
  color_primaries.l                         ;- Enum to do
  color_trc.l                               ;- Enum to do
  colorspace.l                              ;- Enum to do
  color_range.l                             ;- Enum to do           
  chroma_sample_location.l                  ;- Enum to do     
  *execute2.l
  weighted_p_pred.l
  aq_mode.l
  aq_strength.f
  psy_rd.f
  psy_trellis.f
  rc_lookahead.l
  crf_max.f
  log_level_offset.l
  lpc_type.l                               ;- Enum to do  
  lpc_passes.l
  slices.l
  subtitle_header.b
  subtitle_header_size.l
  *pkt.AVPacket
  is_copy.l
  thread_type.l
  active_thread_type.l
  thread_safe_callbacks.l
  vbv_delay.q
  audio_service_type.l                      ;- Enum to do
  request_sample_fmt.l                      ;- Enum to do
  pts_correction_num_faulty_pts.q
  pts_correction_num_faulty_dts.q
  pts_correction_last_pts.q
  pts_correction_last_dts.q
  lpc_coeff_precision.l
  prediction_order_method.l
  min_partition_order.l
  max_partition_order.l   
EndStructure


;- AVStream 
;  http://ffmpeg.org/doxygen/trunk/structAVStream.html
Structure AVStream_Info_
  last_dts.q
  duration_gcd.q
  duration_count.l
  duration_error.d[#MAX_STD_TIMEBASES]
  codec_info_duration.q
EndStructure

;- AVFrac
;  http://ffmpeg.org/doxygen/trunk/structAVFrac.html
Structure AVFrac
  val.q
  num.q
  den.q
EndStructure


Structure AVStream 
  index.l
  id.l
  *codec.AVCodecContext                     
  *r_frame_rate.AVRational
  *prv_data
  first_dts.q
  pts.AVFrac
  time_base.AVRational
  pts_wrap_bits.l
  stream_copy.l
  discard.l                                 ;- Enum to do
  quality.f  
  start_time.q
  duration.q
  need_parsing.l                            ;- Enum to do
  *parser.AVCodecParserContext              
  cur_dts.q
  last_IP_duration.l
  last_IP_pts.q
  *index_entries.AVIndexEntry               
  nb_index_entries.l
  index_entries_allocated_size.l
  nb_frames.q
  dispostion.l
  probe_data.AVProbeData                   
  pts_buffer.q[#MAX_REORDER_DELAY+1]
  sample_aspect_ratio.AVRational
  *metadata.AVDictionary                    
  *cur_ptr.b
  cur_len.l
  cur_pkt.AVPacket                          
  reference_dts.q
  probe_packets.l
  *last_in_packet_buffer.AVPackedList       ; 
  avg_frame_rate.AVRational
  codec_info_nb_frames.l
  stream_identifer.l
  info.AVStream_Info_
  request_probe.l
EndStructure

;- AVPacketList
;  http://ffmpeg.org/doxygen/trunk/structAVPacketList.html
Structure AVPacketList
  pkt.AVPacket
  *Next.AVPacketList
EndStructure

;- AVProgram 
;  http://ffmpeg.org/doxygen/trunk/structAVProgram.html
Structure AVProgram 
  id.l
  flags.l
  discard.l                                  ;- Enum to do
  *stream_index.l
  nb_steam_indexes.l
  metadata.AVDictionary 
  program_num.l
  pmt_pid.l
  pcr_pid.l
EndStructure

;- AVChapter
;  http://ffmpeg.org/doxygen/trunk/structAVFormatContext.html
Structure AVChapter
  id.l
  time_base.AVRational
  start.q
  avend.q
  *metada.AVDictionary 
EndStructure


;- AVFormatContext
;  http://ffmpeg.org/doxygen/trunk/structAVFormatContext.html
Structure AVFormatContext 
  *av_class.AVClass                          
  *iformat.AVInputFormat                     
  *oformat.AVOutputFormat                   
  *priv_data
  *pb.AVIOContext 
  nb_streams.l
  *streams.AVStream[#MAX_STREAMS]           
  filename.b[1024]                          
  timestamp.q
  ctx_flags.l                              
  *packet_buffer.AVPacketList              
  start_time.q                              
  duration.q                                
  file_size.q                               
  bit_rate.l                               
  *cur_st.AVStream                          
  data_offset.q                             
  mux_rate.l
  packet_size.l
  preload.l
  max_delay.l
  loop_output.l
  flags.l
  loop_input.l                              
  probesize.l                               
  max_analyze_duration.l                     
  *key.b
  keylen.l
  nb_programs.l
  *programs.AVProgram[#MAX_PROGRAMMS]       
  video_codec_id.l                           
  audio_codec_id.l                          
  subtitle_codec_id.l                        
  max_index_size.l                           
  max_picture_buffer.l                          
  nb_chapters.l
  chapters.AVChapter[100]
  avdebug.l                                 
  *raw_packet_buffer.AVPacketList           
  *raw_packet_buffer_end.AVPacketList
  *packet_buffer_end.AVPacketList
  *metadata.AVDictionary
  raw_packet_buffer_remaining_size.l
  start_time_realtime.q                     
  fps_probe_size.l 
  error_recognition.l                        
  ts_id.l                                    
EndStructure



;- Struct to do AVFormatParameters
; IDE Options = PureBasic 4.60 Beta 3 (Windows - x86)
; CursorPosition = 85
; FirstLine = 83
; EnableXP